#!/bin/sh
#************************************************************************************************************#
# ScriptName:				dns.cgi    
# Author:				Hunter Fu (fuhualgd <at> qq.com)              
# Date:          			2006.08.09       
# Function: 				Query GSLB Domain Record        
# Version:				1.0            
#************************************************************************************************************#

Htdoc_Dir="/var/www/html"
path=`dirname $0`
template="$Htdoc_Dir/domain/dns_query.html"
country_code="$Htdoc_Dir/domain/country_code.txt"
dns_list="$Htdoc_Dir/domain/dns_server.list"
tmp_file="$Htdoc_Dir/domain/tmp_file"

# invoke cgi module
. $path/lib/conv.shell

# get query parm value

get_value query2   # query domain name
get_value cn_name  # selected country name

# define var
REPLACESTRING=""
country_list=`awk '{print $1}' $dns_list | sort -u|tr -s '\n' ' '`


########### Main Program #############


if [ -z "$cn_name" ];then
	COUNTRY_LIMIT=30
	RANDOM_COUN=""
	for ((a=1; a <= COUNTRY_LIMIT ; a++)) # Double parentheses, and "LIMIT" with no "$".
	do
        	RANDOM_COUN="`expr $RANDOM % 150` $RANDOM_COUN"
	done
fi
#
#############################################
#
# select country
for cn in $country_list
do
	country=`grep $cn $country_code | awk '{print $1}'`
        if [ -z "$country" ];then
             country=$cn
        fi
	country_list_name="<option value=$cn>$country</option> $country_list_name"
done

#
##############################################
#
#	print page
echo "Content-type: text/html; charset=utf-8" 
echo ""
echo "<html><body leftmargin=0 topmargin=0 marginheight=0 marginwidth=0>"
cat $template |sed -e "s!country_list!$country_list_name!g" >$tmp_file 
echo "`cat $tmp_file`"  
#
#############################################
#
#	random select
if [ -n "$query2" ] && [ -z "$cn_name" ];then
	
	echo "<table  align=center border=0 cellpadding=0 cellspacing=0 width=760>"
	echo "<tr ><td colspan=3 align=center>QYERY DNS NAME : $query2 </td></tr>"
	echo "<tr bgcolor=><td>国家名称</td><td>DNS服务器ip</td><td>查询结果</td></tr>"       
	echo "</table>"
	# query function
	mod_count=1
	cn_count=1
	for cn in $country_list
	do
		if ( ! echo "$RANDOM_COUN" | grep -q -w $cn_count)
		then
			cn_count=`expr $cn_count \+ 1`
			continue
		fi
		query_count=1
        	res=`expr $mod_count % 2`
        	country=`grep $cn $country_code | awk '{print $1}'`
		if [ -z "$country" ];then
			country=$cn
		fi
        	dns_query_list=`grep $cn $dns_list | sort -u|head -15|awk '{print $2}'|tr -s '\n' ' '`
        	for dns_query in $dns_query_list
        	do
			if [ $query_count -eq 6 ];then
				break
			fi
                	query_result=`dig +short @$dns_query $query2`
			# no query result or connection time out ,continue
			if [ -z "$query_result" ];then
				continue
			else 
				if ( echo "$query_result"| grep -q -i "connection timed out" )
				then
					continue
				fi
			fi

                	if [  $res -eq 0 ];then
                        	echo "<table align=center border=0 cellpadding=2 cellspacing=1 width=760><tr bgcolor=#b3da3d><td width=200>$country</td><td width=200>$dns_query</td><td width=360>$query_result</td></tr></table>"
                	else
                        	echo "<table align=center border=0 cellpadding=2 cellspacing=1 width=760><tr bgcolor=#e7f3b5><td width=200 >$country</td><td width=200>$dns_query</td><td width=360>$query_result</td></tr></table>"
                	fi
			query_count=`expr $query_count \+ 1`
        	done
        mod_count=`expr $mod_count \+ 1`
	cn_count=`expr $cn_count \+ 1`
	done
fi
#
##################################################
#
#     customer select 
if [ -n "$query2" ] && [ -n "$cn_name" ];then

        echo "<table  align=center border=0 cellpadding=0 cellspacing=0 width=760>"
        echo "<tr ><td colspan=3 align=center>QYERY DNS NAME : $query2 </td></tr>"
        echo "<tr bgcolor=><td>国家名称</td><td>DNS服务器ip</td><td>查询结果</td></tr>"       
        echo "</table>"
        # query function
        mod_count=1
        for cn in $cn_name
        do
                query_count=1
                res=`expr $mod_count % 2`
                country=`grep $cn $country_code | awk '{print $1}'`
                if [ -z "$country" ];then
                        country=$cn
                fi
                dns_query_list=`grep $cn $dns_list | sort -u|head -15|awk '{print $2}'|tr -s '\n' ' '`
                for dns_query in $dns_query_list
                do
                        if [ $query_count -eq 6 ];then
                                break
                        fi
                        query_result=`dig +short @$dns_query $query2`
                        # no query result or connection time out ,continue
                        if [ -z "$query_result" ];then
                                continue
                        else 
                                if ( echo "$query_result"| grep -q -i "connection timed out" )
                                then
                                        continue
                                fi
			fi

                        if [  $res -eq 0 ];then
                                echo "<table align=center border=0 cellpadding=2 cellspacing=1 width=760><tr bgcolor=#b3da3d>
<td width=200>$country</td><td width=200>$dns_query</td><td width=360>$query_result</td></tr></table>"
                        else
                                echo "<table align=center border=0 cellpadding=2 cellspacing=1 width=760><tr bgcolor=#e7f3b5>
<td width=200 >$country</td><td width=200>$dns_query</td><td width=360>$query_result</td></tr></table>"
                        fi
                        query_count=`expr $query_count \+ 1`
                done
        mod_count=`expr $mod_count \+ 1`
        done
fi
#
############################################
#
#	print footer
echo "<br>"
echo "<table  align=center border=0 cellpadding=0 cellspacing=0 width=760>"
echo "<tr ><td><hr color=#b3da3d noshade=noshade size=1></td></tr>"
echo "<tr ><td align=center ><a href="http://www.opensolution.org.cn">开放方案 OpenSolution</a> 出品</td></tr>"
echo "</table>"
echo "</body></html>"
